package com.truckitin.core.model

import android.os.Parcelable
import androidx.annotation.Keep
import com.truckitin.core.enums.BookingStatus
import com.truckitin.core.enums.LoadingWindow
import com.truckitin.core.enums.PaymentWindow
import kotlinx.parcelize.Parcelize

@Keep
@Parcelize
data class AddaModel (
    val bookingStatus: BookingStatus,
    val consigneeName: String,
    val dropoffAddress: String,
    val dropoffCity: String,
    val goodsType: String,
    val id: Int,
    val loadingTime: String,
    val loadingWindowType: LoadingWindow,
    val paymentReceivingType: PaymentWindow,
    val pickupAddress: String,
    val pickupCity: String,
    val vehicleType: String,
    val vehicleTypeVariant: String,
    val weight: Double,
    val specialInstructions: String,
    /*----*/
    val dropoffCityId: Int,
    val dropoffLatitude: Double,
    val dropoffLongitude: Double,
    val dropoffType: String,
    val goodsTypeId: Int,
    val labourAvailabilityType: String,
    val packaging: String,
    val pickupCityId: Int,
    val pickupLatitude: Double,
    val pickupLongitude: Double,
    val pickupType: String,
    val shipmentId: Int,
    val vehicleTypeId: Int,
    val vehicleTypeVariantId: Int,
    val driverName: String?,
    val driverId: Int?,
    val vehicleId: Int?,
    val vehicleRegistration: String?,
    val modelYear: String?,
    val modelName: String?,
    val driverNumber: String?,
    val goodsDescription: String?,
    val competitiveBidAmount: Long = 0,
    val totalBidsPerBooking: Long = 0,
    val bidWindowStartDateTime: String?,
    val bidWindowEndDateTime: String?,
    val tagId: Int,
    val documentsAvailable: Boolean = false,
    val expensesAvailable: Boolean = false,
    val buyingAndSellingAvailable: Boolean = false,
    val bidCategoryTypeId:Int?,
    var bidAmount: Double,
    var offeredWeight: Double? = null,
    val shipmentLocations: List<ShipmentLocationsResponseDto>

) : Parcelable {
    constructor(postedBids: PostedBid) : this(
        bookingStatus = postedBids.bookingStatus,
        consigneeName = postedBids.consigneeName,
        dropoffAddress = postedBids.dropoffAddress,
        dropoffCity = postedBids.dropoffCity,
        goodsType = postedBids.goodsType,
        id = postedBids.bookingId,
        loadingTime = postedBids.loadingTime,
        loadingWindowType = postedBids.loadingWindowType,
        paymentReceivingType = postedBids.paymentReceivingType,
        pickupAddress = postedBids.pickupAddress,
        pickupCity = postedBids.pickupCity,
        vehicleType = postedBids.vehicleType,
        vehicleTypeVariant = postedBids.vehicleTypeVariant,
        weight = postedBids.weight,
        specialInstructions = postedBids.specialInstructions,
        dropoffCityId = postedBids.dropoffCityId,
        dropoffLatitude = postedBids.dropoffLatitude,
        dropoffLongitude = postedBids.dropoffLatitude,
        dropoffType = postedBids.dropoffType,
        goodsTypeId = postedBids.goodsTypeId,
        labourAvailabilityType = postedBids.labourAvailabilityType,
        packaging = postedBids.packaging,
        pickupCityId = postedBids.pickupCityId,
        pickupLatitude = postedBids.pickupLatitude,
        pickupLongitude = postedBids.pickupLongitude,
        pickupType = postedBids.pickupType,
        shipmentId = postedBids.shipmentId,
        vehicleTypeId = postedBids.vehicleTypeId,
        vehicleTypeVariantId = postedBids.vehicleTypeVariantId,
        driverName = postedBids.driverName,
        driverId = postedBids.driverId,
        vehicleId = postedBids.vehicleId,
        vehicleRegistration = postedBids.vehicleRegistration,
        modelYear = postedBids.modelYear,
        modelName = postedBids.modelName,
        driverNumber = postedBids.driverNumber,
        goodsDescription = postedBids.goodsDescription,
        competitiveBidAmount = postedBids.competitiveBidAmount,
        totalBidsPerBooking = postedBids.totalBidsPerBooking,
        bidWindowStartDateTime = postedBids.bidWindowStartDateTime,
        bidWindowEndDateTime = postedBids.bidWindowEndDateTime,
        tagId = postedBids.tagId,
        documentsAvailable = postedBids.documentsAvailable,
        expensesAvailable = postedBids.expensesAvailable,
        buyingAndSellingAvailable = postedBids.buyingAndSellingAvailable,
        bidCategoryTypeId = postedBids.bidCategoryTypeId,
        bidAmount = postedBids.bidAmount,
        offeredWeight = postedBids.offeredWeight,
        shipmentLocations = postedBids.shipmentLocations
    )

    fun getVehicleName() = "$modelName | $vehicleRegistration"
}
